<?php
/**
 * CalculationTariff
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\LogisticClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Logistic
 *
 * Управление логистикой
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\LogisticClient\Dto;

use \ArrayAccess;
use \Ensi\LogisticClient\ObjectSerializer;

/**
 * CalculationTariff Class Doc Comment
 *
 * @category Class
 * @package  Ensi\LogisticClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class CalculationTariff implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'CalculationTariff';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'external_id' => 'int',
        'name' => 'string',
        'delivery_service_cost' => 'int',
        'days_min' => 'int',
        'days_max' => 'int',
        'available_dates' => '\Ensi\LogisticClient\Dto\CalculationAvailableDate[]',
        'point_ids' => 'int[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'external_id' => null,
        'name' => null,
        'delivery_service_cost' => null,
        'days_min' => null,
        'days_max' => null,
        'available_dates' => null,
        'point_ids' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'external_id' => false,
        'name' => false,
        'delivery_service_cost' => false,
        'days_min' => false,
        'days_max' => false,
        'available_dates' => false,
        'point_ids' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'external_id' => 'external_id',
        'name' => 'name',
        'delivery_service_cost' => 'delivery_service_cost',
        'days_min' => 'days_min',
        'days_max' => 'days_max',
        'available_dates' => 'available_dates',
        'point_ids' => 'point_ids'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'external_id' => 'setExternalId',
        'name' => 'setName',
        'delivery_service_cost' => 'setDeliveryServiceCost',
        'days_min' => 'setDaysMin',
        'days_max' => 'setDaysMax',
        'available_dates' => 'setAvailableDates',
        'point_ids' => 'setPointIds'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'external_id' => 'getExternalId',
        'name' => 'getName',
        'delivery_service_cost' => 'getDeliveryServiceCost',
        'days_min' => 'getDaysMin',
        'days_max' => 'getDaysMax',
        'available_dates' => 'getAvailableDates',
        'point_ids' => 'getPointIds'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('external_id', $data, null);
        $this->setIfExists('name', $data, null);
        $this->setIfExists('delivery_service_cost', $data, null);
        $this->setIfExists('days_min', $data, null);
        $this->setIfExists('days_max', $data, null);
        $this->setIfExists('available_dates', $data, null);
        $this->setIfExists('point_ids', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['external_id'] === null) {
            $invalidProperties[] = "'external_id' can't be null";
        }
        if ($this->container['name'] === null) {
            $invalidProperties[] = "'name' can't be null";
        }
        if ($this->container['delivery_service_cost'] === null) {
            $invalidProperties[] = "'delivery_service_cost' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets external_id
     *
     * @return int
     */
    public function getExternalId()
    {
        return $this->container['external_id'];
    }

    /**
     * Sets external_id
     *
     * @param int $external_id Id тарифа в службе доставки
     *
     * @return $this
     */
    public function setExternalId($external_id)
    {


        /*if (is_null($external_id)) {
            throw new \InvalidArgumentException('non-nullable external_id cannot be null');
        }*/
        $this->container['external_id'] = $external_id;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string $name Наименование тарифа
     *
     * @return $this
     */
    public function setName($name)
    {


        /*if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }*/
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets delivery_service_cost
     *
     * @return int
     */
    public function getDeliveryServiceCost()
    {
        return $this->container['delivery_service_cost'];
    }

    /**
     * Sets delivery_service_cost
     *
     * @param int $delivery_service_cost Стоимость доставки от службы доставки (в копейках)
     *
     * @return $this
     */
    public function setDeliveryServiceCost($delivery_service_cost)
    {


        /*if (is_null($delivery_service_cost)) {
            throw new \InvalidArgumentException('non-nullable delivery_service_cost cannot be null');
        }*/
        $this->container['delivery_service_cost'] = $delivery_service_cost;

        return $this;
    }

    /**
     * Gets days_min
     *
     * @return int|null
     */
    public function getDaysMin()
    {
        return $this->container['days_min'];
    }

    /**
     * Sets days_min
     *
     * @param int|null $days_min Минимальное количество дней на доставку
     *
     * @return $this
     */
    public function setDaysMin($days_min)
    {


        /*if (is_null($days_min)) {
            throw new \InvalidArgumentException('non-nullable days_min cannot be null');
        }*/
        $this->container['days_min'] = $days_min;

        return $this;
    }

    /**
     * Gets days_max
     *
     * @return int|null
     */
    public function getDaysMax()
    {
        return $this->container['days_max'];
    }

    /**
     * Sets days_max
     *
     * @param int|null $days_max Максимальное количество дней на доставку
     *
     * @return $this
     */
    public function setDaysMax($days_max)
    {


        /*if (is_null($days_max)) {
            throw new \InvalidArgumentException('non-nullable days_max cannot be null');
        }*/
        $this->container['days_max'] = $days_max;

        return $this;
    }

    /**
     * Gets available_dates
     *
     * @return \Ensi\LogisticClient\Dto\CalculationAvailableDate[]|null
     */
    public function getAvailableDates()
    {
        return $this->container['available_dates'];
    }

    /**
     * Sets available_dates
     *
     * @param \Ensi\LogisticClient\Dto\CalculationAvailableDate[]|null $available_dates Доступные даты для доставки
     *
     * @return $this
     */
    public function setAvailableDates($available_dates)
    {


        /*if (is_null($available_dates)) {
            throw new \InvalidArgumentException('non-nullable available_dates cannot be null');
        }*/
        $this->container['available_dates'] = $available_dates;

        return $this;
    }

    /**
     * Gets point_ids
     *
     * @return int[]|null
     */
    public function getPointIds()
    {
        return $this->container['point_ids'];
    }

    /**
     * Sets point_ids
     *
     * @param int[]|null $point_ids Список Id точек выдачи заказа
     *
     * @return $this
     */
    public function setPointIds($point_ids)
    {


        /*if (is_null($point_ids)) {
            throw new \InvalidArgumentException('non-nullable point_ids cannot be null');
        }*/
        $this->container['point_ids'] = $point_ids;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


